//
//  ViewController.m
//  ConcentrationTryOne
//
//  Created by robert curtis on 11/8/11.
//  Copyright (c) 2011 __MyCompanyName__. All rights reserved.
//

#import "ViewController.h"
@interface ViewController()

-(void)loadCardBackFaces;
-(void)loadCardFaces;
-(void)jumbleUpCards;


@end

@implementation ViewController
@synthesize card1;
@synthesize card2;
@synthesize card3;
@synthesize card4;
@synthesize card5;
@synthesize card6;
@synthesize card7;
@synthesize card8;
@synthesize card9;
@synthesize card10;
@synthesize card11;
@synthesize card12;
@synthesize cards;
@synthesize turns;
@synthesize showingCards;
@synthesize guessedCards;
@synthesize timeLabel;

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    turns = 0;
    showingCards = [[NSMutableArray alloc] initWithCapacity:3];
    guessedCards = [[NSMutableArray alloc] initWithCapacity:13];
    
    timer = [NSTimer scheduledTimerWithTimeInterval:1.0
                                             target:self 
                                           selector:@selector(handleTimer) 
                                           userInfo:nil 
                                            repeats:YES];
    time = 30;
    cards = [NSMutableArray arrayWithObjects:card1, card2, card3, card4, card5, card6, card7, card8, card9, card10, card11, card12, nil];
    
    [self loadCardBackFaces];
    [self jumbleUpCards];
    [self loadCardFaces];
}

-(void)loadCardBackFaces
{
    for(Card * card in cards)
    {
        card.backCard = [UIImage imageNamed:@"back.png"];
        card.image = card.backCard;
        card.faceID = [NSNumber numberWithInt:-1];
    }
}

-(void)loadCardFaces
{
    int counter = 0;
    int cardValue = 0;
    for(Card *card in cards)
    {
        if(counter < 2)
        {
            card.faceID = [NSNumber numberWithInt:cardValue];
            counter++;
        }
        else
        {
            cardValue++;
            card.faceID = [NSNumber numberWithInt:cardValue];
            counter = 1;
        }
    }
    
    for(Card *card in cards)
    {
        if(card.faceID == [NSNumber numberWithInt:0])
        {
            card.faceCard = [UIImage imageNamed:@"bluePolygon.png"];
        }
        if(card.faceID == [NSNumber numberWithInt:1])
        {
            card.faceCard = [UIImage imageNamed:@"greenArrow.png"];
        }
        if(card.faceID == [NSNumber numberWithInt:2])
        {
            card.faceCard = [UIImage imageNamed:@"purpleBolt.png"];
        }
        if(card.faceID == [NSNumber numberWithInt:3])
        {
            card.faceCard = [UIImage imageNamed:@"redCircle.png"];
        }
        if(card.faceID == [NSNumber numberWithInt:4])
        {
            card.faceCard = [UIImage imageNamed:@"yellowSun.png"];
        }
        if(card.faceID == [NSNumber numberWithInt:5])
        {
            card.faceCard = [UIImage imageNamed:@"purpleCircle.png"];
        }
    }
    
}

-(void)jumbleUpCards
{
    for(NSInteger x = 0; x < [cards count]; x++)
    {
        NSInteger randInt = arc4random() % ([cards count] - x) + x;
        [cards exchangeObjectAtIndex:x withObjectAtIndex:randInt];
    }
}

-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    UITouch *touch = [[event allTouches] anyObject];
    for(Card * card in cards)
    {
        if(CGRectContainsPoint([card frame], [touch locationInView:self.view]))
           {
               if([showingCards count] < 2)
               {
                   card.image = card.faceCard;
                   [showingCards addObject:card];
                   NSLog(@"showingCard count = %d", [showingCards count]);
                   
                   if([showingCards count] == 2)
                   {
                       Card *firstCard = [showingCards objectAtIndex:0];
                       Card *secondCard = [showingCards objectAtIndex:1];
                       
                       if(firstCard.image == secondCard.image)
                       {
                           [guessedCards addObjectsFromArray:showingCards];
                           [showingCards removeAllObjects];
                       }
                   }
                   
               }
               else
               {                   
                   for(Card * flippedcards in showingCards)                   
                   {
                       flippedcards.image = flippedcards.backCard;
                       
                   }
                   [showingCards removeAllObjects];
               }
           }
    }
    if([guessedCards count] == [cards count])
    {
        [timer invalidate];
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Victory!" 
                                                        message:@"Victory!" 
                                                       delegate:self 
                                              cancelButtonTitle:@"OK" 
                                              otherButtonTitles: nil];
        [alert show];
    }
}

-(void)handleTimer
{
    if(time > 0)
    {
        time -= 1;        
        timeLabel.text = [NSString stringWithFormat:@"Time: %d", time];
    }
    else
    {
        [timer invalidate];        
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Losser!" 
                                                        message:@"Losser!" 
                                                       delegate:self 
                                              cancelButtonTitle:@"OK" 
                                              otherButtonTitles: nil];
        [alert show];
    }
    
}

- (IBAction)resetButton:(id)sender
{
    turns = 0;
    time = 30;
    showingCards = [[NSMutableArray alloc] initWithCapacity:3];
    guessedCards = [[NSMutableArray alloc] initWithCapacity:13];
    
    timer = [NSTimer scheduledTimerWithTimeInterval:1.0
                                             target:self 
                                           selector:@selector(handleTimer) 
                                           userInfo:nil 
                                            repeats:YES];
    
    [self loadCardBackFaces];
    [self jumbleUpCards];
    [self loadCardFaces];
}






















- (void)viewDidUnload
{
    [self setCard1:nil];
    [self setCard2:nil];
    [self setCard3:nil];
    [self setCard4:nil];
    [self setCard5:nil];
    [self setCard6:nil];
    [self setCard7:nil];
    [self setCard8:nil];
    [self setCard9:nil];
    [self setCard10:nil];
    [self setCard11:nil];
    [self setCard12:nil];
    [self setTimeLabel:nil];
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

@end
